#include <iostream>
#include <string>
#include <typeinfo>

using std::cout;
using std::endl;

template <class T>
class Pilha
{
public:
  Pilha();
  ~Pilha();
  void insere(const T &valor);
  void retira();
  void imprime();

private:
  T *minhaPilha;
  int tam;
  const char *nomeTipo;
};

template <class T>
Pilha<T>::Pilha()
{ 
  tam = 0;
  minhaPilha = new T[5];
  nomeTipo = typeid( T ).name();
}

template <class T>
Pilha<T>::~Pilha()
{
  delete [] minhaPilha;
}

template <class T>
void Pilha<T>::insere(const T &valor)
{
  if(tam < 5)
  {
    minhaPilha[tam] = valor;
    cout << "Inseriu '" << minhaPilha[tam] << "' na pilha do tipo " << nomeTipo << endl;
    tam++;
  }
  else
    cout << "Overflow!!! Pilha Cheia!!! -> " << valor << " no inserido!" << endl;
}

template <class T>
void Pilha<T>::retira()
{
  if(tam > 0)
  {
    tam--;
    cout << "Retirou '" << minhaPilha[tam] << "' da pilha do tipo " << nomeTipo << endl;
    minhaPilha[tam] = NULL;
  }
  else
    cout << "Underflow!!! Pilha Vazia!!!" << endl;
}

template <class T>
void Pilha<T>::imprime()
{
  for (int i = 0; i < tam ; i++)
    cout << "Listando elemento " << i << " da pilha do tipo " << nomeTipo << ": " << minhaPilha[i] << endl;

  cout << endl;
}
